import * as React from "react";
import { FormGroupProviderProps } from "./FormGroupProviderProps";
import { FormGroupContextInterface } from "./FormGroupContext";
import { FormContextInterface } from "../FormProvider";
interface FormGroupProviderState {
    isFocused: boolean;
}
export declare class FormGroupProvider extends React.PureComponent<FormGroupProviderProps, FormGroupProviderState> {
    static readonly propTypes: import("prop-types").ValidationMap<FormGroupProviderProps>;
    readonly state: FormGroupProviderState;
    render(): React.ReactNode;
    protected renderChildren: (formContext: FormContextInterface<import("../../Validators/AbstractValidator").UncertainObject<any>>) => React.ReactNode;
    protected createChildContext: (formContext: FormContextInterface<import("../../Validators/AbstractValidator").UncertainObject<any>>) => FormGroupContextInterface;
    protected handleRegisterElement: (formContext: FormContextInterface<import("../../Validators/AbstractValidator").UncertainObject<any>>) => (element: any) => void;
    protected handleUnergisterElement: (formContext: FormContextInterface<import("../../Validators/AbstractValidator").UncertainObject<any>>) => () => void;
    protected handleChange: (formContext: FormContextInterface<import("../../Validators/AbstractValidator").UncertainObject<any>>) => (value: any) => void | Promise<void>;
    protected handleBlur: (formContext: FormContextInterface<import("../../Validators/AbstractValidator").UncertainObject<any>>) => () => void | Promise<void>;
    protected handleFocus: (formContext: FormContextInterface<import("../../Validators/AbstractValidator").UncertainObject<any>>) => () => void | Promise<void>;
    private readonly shouldValidateOnBlur;
    private readonly shouldValidateOnFocus;
    private readonly shouldValidateOnChange;
    private shouldValidateOnMethod;
}
export {};
